#
# Copyright (c) 2004, 2005 Brian Sutherland <jinty@web.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""Some Common functions used in the tests"""

from StringIO import StringIO
from logilab.xmldiff import input, format, fmes
from xml.dom import ext


def stringify(element):
    """Convert a DOM element to a nice looking string."""
    outstr = StringIO()
    ext.PrettyPrint(element, outstr)
    return outstr.getvalue()

def verifyStrings(str1, str2):
    """Compares two strings of XML to see if they are equal.

    Prints a diff if they are not and raises an AssertionError.

    EXPERIMENTAL METHOD TO REPLACE verifyStrings - just the output formatting
    is extreemly unreadable....
    """
    tree1 = input.tree_from_stream(StringIO(str1), include_comment=0)
    tree2 = input.tree_from_stream(StringIO(str2), include_comment=0)
    formatter = format.InternalPrinter()
    strategy = fmes.FmesCorrector(formatter)
    strategy.process_trees(tree1, tree2)
    assert len(formatter.edit_s) == 0
